(defglobal MAIN ?*id* = 1)
(defglobal MAIN ?*count* = 1)
(defglobal MAIN ?*temp* = "")

(deftemplate MAIN::Model
  (slot ID (type NUMBER))
  (slot Name (type STRING)))

(deftemplate MAIN::Step
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER))
  (slot Type (type SYMBOL) (allowed-symbols Primitive Compound Defined Dummy) (default Primitive))
  (slot AssignWorker (type SYMBOL) (allowed-symbols Yes No) (default Yes))
  (slot CorrespondingModelID (type NUMBER)))

(deftemplate MAIN::InitialPoint
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::MetaPoint
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::FinalPoint
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::Resource
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER))
  (slot Type (type SYMBOL) (allowed-symbols Owner Worker SW HW) (default Worker))
  (slot Policy (type SYMBOL))
  (slot Form (type SYMBOL) (allowed-symbols Common Assigned) (default Common)))

(deftemplate MAIN::ArtifactStore
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot Path (type STRING)))

(deftemplate MAIN::Organization
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::EventBinder
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::Precondition
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::Postcondition
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER)))

(deftemplate MAIN::Link
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot From (type NUMBER))
  (slot To (type NUMBER))
  (slot Type (type SYMBOL) (allowed-symbols ResourceLink PreconditionLink PostconditionLink) (default ResourceLink)))

(deftemplate MAIN::NumberOfWorker
	(slot ID (type NUMBER))
	(slot ModelID (type NUMBER))
	(slot StepID (type NUMBER))
	(slot WorkerNum (type NUMBER)))

(deftemplate MAIN::ArtifactFlow
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot From (type NUMBER))
  (slot To (type NUMBER))
  (slot ArtifactName (type STRING))
  (slot IOMode (type SYMBOL))
  (slot Type (type SYMBOL) (allowed-symbols General Optional) (default General))
  (slot Relationship (type STRING)))

(deftemplate MAIN::EventFlow
  (slot ID (type NUMBER))
  (slot Name (type STRING))
  (slot ModelID (type NUMBER))
  (slot From (type NUMBER))
  (slot To (type NUMBER))
  (slot ArtifactName (type STRING))
  (slot Type (type SYMBOL) (allowed-symbols General Multi Optional) (default General)))

(deftemplate MAIN::ConnectingOperator
  (slot ID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot Type (type SYMBOL) (allowed-symbols IN-OR IN-AND OUT-OR OUT-AND))
  (slot StepState (type SYMBOL) (allowed-symbols R A I S E Initial Final Meta))
  (slot StepID (type NUMBER))
  (slot FlowNum (type NUMBER) (default 0)))

(deftemplate MAIN::OModel
  (slot OID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot State (type SYMBOL) (allowed-symbols I E)))

(deftemplate MAIN::OConnectingOperator
  (slot OID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot ModelOID (type NUMBER))
  (slot ConnectingOperatorID (type NUMBER))
  (slot StepID (type NUMBER))
  (slot ArtifactName (type STRING))
  (multislot ArtifactOID (type NUMBER)))

(deftemplate MAIN::OEventFlow
  (slot OID (type NUMBER))
  (slot ModelOID (type NUMBER))
  (slot EventFlowID (type NUMBER))
  (slot ArtifactName (type STRING))
  (multislot ArtifactOID (type NUMBER))
  (slot Frequency (type NUMBER) (default 0)))

(deftemplate MAIN::OArtifactFlow
  (slot OID (type NUMBER))
  (slot ModelOID (type NUMBER))
  (slot ArtifactFlowID (type NUMBER))
  (slot ArtifactName (type STRING))
  (slot ArtifactOID (type NUMBER)))

(deftemplate MAIN::OStep
  (slot OID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot ModelOID (type NUMBER))
  (slot State (type SYMBOL) (allowed-symbols R A I S E Initiating))
  (slot StepID (type NUMBER)))
  
(deftemplate MAIN::RequestAssignWorker
	(slot StepName (type STRING))
	(slot Worker (type STRING))
	(slot StepID (type NUMBER))
  (slot ModelID (type NUMBER)))
  
(deftemplate MAIN::ResponseAssignWorker
	(slot StepName (type STRING))
	(slot Worker (type STRING))
	(slot WorkerOID (type INTEGER)))

(deftemplate MAIN::RequestArtifact
  (slot ArtifactStoreID (type NUMBER)) 
  (slot ArtifactFlowID (type NUMBER)) 
  (slot Path (type STRING))
  (slot ModelID (type NUMBER))
  (slot ArtifactName (type STRING)))
  
(deftemplate MAIN::ResponseArtifact
  (slot ModelID (type NUMBER))
  (slot ArtifactStoreID (type NUMBER)) 
  (slot ArtifactFlowID (type NUMBER)) 
  (slot ArtifactName (type STRING))
  (slot ArtifactOID (type NUMBER)))

(deftemplate MAIN::InputArtifact
	(slot ArtifactName (type STRING))
	(slot ArtifactOID (type NUMBER))
	(slot ModelName (type STRING))
	(slot ModelID (type NUMBER)))
	
(deftemplate MAIN::OutputArtifact
	(slot ArtifactName (type STRING))
	(slot ArtifactOID (type NUMBER))
	(slot ModelName (type STRING))
	(slot ModelID (type NUMBER)))
	
(deftemplate MAIN::ModelinputArtifact
	(slot ArtifactName (type STRING))
	(multislot ArtifactOID (type NUMBER))
	(slot ModelID (type NUMBER)))

(deftemplate MAIN::InputArtifactInfo
	(slot Name (type STRING))
	(multislot ArtifactOID (type NUMBER))
	(slot StepID (type NUMBER))
	(slot ModelID (type NUMBER)))
	
(deftemplate MAIN::OutputArtifactInfo
	(slot Name (type STRING))
	(multislot ArtifactOID (type NUMBER))
	(slot EventFlowName (type STRING) (default "nothing"))
	(slot StepID (type NUMBER))
	(slot ModelID (type NUMBER))
	(slot Output (type SYMBOL) (allowed-symbols Determined NonDetermined)))
	
(deftemplate MAIN::Candidate_OutputArtifactInfo
	(slot Name (type STRING))
	(slot StepID (type NUMBER))
	(slot ModelID (type NUMBER)))
	
(deftemplate MAIN::Worker
	(slot Type (type STRING))
	(slot WorkerOID (type INTEGER))
	(slot StepID (type INTEGER))
	(slot ModelID (type NUMBER)))
	
(deftemplate MAIN::EndStep
	(slot StepID (type NUMBER))
	(slot ModelID (type NUMBER)))
	
(deftemplate MAIN::InitiateStep
  (slot WorkerOID (type NUMBER))
  (slot StepName (type STRING))
  (slot StepID (type NUMBER))
  (slot ModelID (type NUMBER)))	

(deftemplate MAIN::PutArtifact
	(slot ArtifactName (type STRING))
	(slot ArtifactOID (type NUMBER))
	(slot ArtifactFlowID (type NUMBER))
	(slot ModelID (type NUMBER))
	(slot Path (type STRING)))

(deftemplate MAIN::Numbers
	(slot ID (type NUMBER))
	(slot ModelID (type NUMBER))
	(slot Name (type NUMBER))
	(slot EventName (type STRING))
	(slot InEvent (type NUMBER) (default 0))
	(slot OutEvent (type NUMBER) (default 0))
	(slot Artifact (type STRING)))

(deftemplate MAIN::ONumbers
	(slot ID (type NUMBER))
  (slot ModelID (type NUMBER))
	(slot ModelOID (type NUMBER))
	(slot NumberID (type NUMBER))
	(slot Type (type SYMBOL)))
		
(deftemplate MAIN::RequestInputArtifact
	(slot ArtifactName (type STRING)))

(deftemplate MAIN::ResponseInputArtifact
	(slot ArtifactName (type STRING))
	(slot ArtifactOID (type NUMBER)))

(deftemplate MAIN::OInitialPoint 
	(slot OID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot InitialPointID (type NUMBER)))

(deftemplate MAIN::OFinalPoint 
	(slot OID (type NUMBER))
  (slot ModelID (type NUMBER))
  (slot FinalPointID (type NUMBER)))

(deftemplate MAIN::RequestBranchMessage 
	(slot ModelID (type NUMBER))
	(slot RelativeConnectingOperatorID (type NUMBER)))

(deftemplate MAIN::ResponseBranchMessage 
	(slot ModelID (type NUMBER))
	(slot EventMessage (type STRING))
	(slot RelativeConnectingOperatorID (type NUMBER)))

(deftemplate MAIN::EnterBranchMessage 
	(slot ModelID (type NUMBER)))

(deftemplate MAIN::EnteredBranchMessage 
	(slot Message (type STRING)))

(deftemplate MAIN::InitiateStepInfo
	(slot ModelID (type NUMBER))
	(slot StepID (type NUMBER))
	(slot Step (type STRING))
	(slot Input (type STRING))
	(slot Output (type STRING))
	(slot WorkerType (type STRING))
	(slot Worker (type NUMBER)))

(deftemplate MAIN::LoadModel
	(slot ModelID (type NUMBER)))

(deftemplate MAIN::TerminateModel
	(slot ModelID (type NUMBER)))

(deftemplate MAIN::InitiateCorrespondingModel
	(slot PreviousModelID (type NUMBER))
	(slot CompoundStepID (type NUMBER))
	(slot ModelName (type STRING))
	(slot ModelID (type NUMBER))
	(slot InputArtifact (type STRING))
	(multislot InputArtifactOID (type NUMBER)))

;****************************************************
;* Fact   ش Fact üȭ ְ
;*   ʱ Input Artifact  
;*Է ޴ Rule
;****************************************************
(defrule MAIN::OModel_1
  (Model (ID ?id) (Name ?name))
  (InitialPoint (ID ?iid) (ModelID ?id))
  =>
  (assert (OModel (OID ?*id*) (ModelID ?id) (State I)))
  (bind ?*id* (+ ?*id* 1))
  (assert (OInitialPoint (OID ?*id*) (ModelID ?id) (InitialPointID ?iid)))
  (bind ?*id* (+ ?*id* 1)))
  
(defrule MAIN::OModel_2
	(declare (salience 2000))
	?x <- (InitiateCorrespondingModel (ModelName ?name) (ModelID ?id) (InputArtifact ?aname) (InputArtifactOID $?aoid))
	(Model (ID ?id) (Name ?name))
	(InitialPoint (ID ?iid) (ModelID ?id))
 =>
 	(retract ?x)
  (assert (OModel (OID ?*id*) (ModelID ?id) (State I)))
  (bind ?*id* (+ ?*id* 1))
  (assert (OInitialPoint (OID ?*id*) (ModelID ?id) (InitialPointID ?iid)))
  (assert (ModelinputArtifact (ModelID ?id) (ArtifactName ?aname) (ArtifactOID ?aoid)))
  (bind ?*id* (+ ?*id* 1)))
  
(defrule MAIN::Request_Input_Artifact_1
	(declare (salience 1000))
	(Model (ID ?id) (Name ?name))
	(OModel (ModelID ?id) (State I))
	(not (LoadModel))
	=>
	(assert (RequestInputArtifact)))
	
(defrule MAIN::Response_Input_Artifact_1
	(declare (salience 1000))
	(Model (ID ?id) (Name ?name))
	(OModel (ModelID ?id) (State I))
	?x <- (RequestInputArtifact)
	?y <- (ResponseInputArtifact (ArtifactName ?aname) (ArtifactOID ?aid))
	(test (and (neq "" ?aname)
						 (<> 0 ?aid)))
	=>
	(retract ?x ?y)
	(assert (ModelinputArtifact (ModelID ?id) (ArtifactName ?aname) (ArtifactOID ?aid))))	

;*************************************************
;*  Worker   ûϴ Rule
;*************************************************
(defrule MAIN::RequestAssignWorker_1
	(declare (salience 1000))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
	(OStep (State Initiating) (StepID ?sid) (ModelOID ?oid))
	(Resource (ID ?rid) (Name ?rname) (ModelID ?mid) (Type Worker) (Form Assigned))
	(Link (ID ?lid) (ModelID ?mid) (From ?rid) (To ?sid) (Type ResourceLink))
	=>
  (assert	(RequestAssignWorker (ModelID ?mid) (StepName ?sname) (Worker ?rname) (StepID ?sid))))
  
;*************************************************************
;*ũ Ǿ   Worker   ûϴ Rule
;*************************************************************
(defrule MAIN::RequestAssignWorker_2
	(declare (salience 1000))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive) (AssignWorker No))
	(OStep (State Initiating) (StepID ?sid) (ModelOID ?oid))
	(Resource (ID ?rid) (Name ?rname) (ModelID ?mid) (Type Worker) (Form Common))
	=>
 (assert	(RequestAssignWorker (ModelID ?mid) (StepName ?sname) (Worker ?rname) (StepID ?sid))))
 
;*************************************************************
;*Worker Ҵ Rule
;************************************************************* 
(defrule MAIN::ResponseAssignWorker_1
	(declare (salience 1000))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (RequestAssignWorker (ModelID ?mid) (StepName ?sname) (Worker ?wname) (StepID ?sid))
	(ResponseAssignWorker (StepName ?sname) (Worker ?wname) (WorkerOID ?woid))
	=>
  (assert (Worker (Type ?wname) (WorkerOID ?woid) (StepID ?sid) (ModelID ?mid))))

(defrule MAIN::Remove_AssignWorkerInfo
  (declare (salience 1000))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Worker (Type ?wname) (WorkerOID ?woid) (StepID ?sid) (ModelID ?mid))
  ?x <- (RequestAssignWorker (ModelID ?mid) (StepName ?sname) (Worker ?wname) (StepID ?sid))
	?y <- (ResponseAssignWorker (StepName ?sname) (Worker ?wname) (WorkerOID ?woid))
	=>
	(retract ?x ?y))

;*********************************************************
;*InitialPoint  ConnectingOperator óϴ Rule
;*********************************************************
(defrule MAIN::ConnectingOperator_1
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(InitialPoint (ID ?iid) (ModelID ?mid))
	?x <- (OInitialPoint (ModelID ?mid) (InitialPointID ?iid))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepID ?iid))
	=>
	(retract ?x)
	(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid)))
	(bind ?*id* (+ ?*id* 1)))

;*********************************************************
;*ConnectingOperator Ÿ OUT-AND  õ 
;*EventFlow  ArtifactFlow  üȭǾ ش
;*ConnectingOperator ϴ Rule
;*********************************************************	
(defrule MAIN::Remove_ConnectingOperator_1
	(declare (salience 1000))
	(OModel (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (FlowNum ?num))
	?x <- (OConnectingOperator (ConnectingOperatorID ?cid))
	(EventFlow (ID ?eid) (ModelID ?mid) (From ?cid))
	(OEventFlow (EventFlowID ?eid) (ArtifactOID $?aoid))
	(test (= 0 (length$ $?aoid)))
	=>
	(if (= ?num ?*count*) then
		(retract ?x)
		(bind ?*count* 1)
	 else
	 		(bind ?*count* (+ ?*count* 1))))

(defrule MAIN::Remove_ConnectingOperator_2
	(declare (salience 1000))
	(OModel (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (FlowNum ?num))
	?x <- (OConnectingOperator (ConnectingOperatorID ?cid))
	(ArtifactFlow (ID ?aid) (ModelID ?mid) (From ?cid) (ArtifactName ?aname))
  ?y <- (PutArtifact (ArtifactName ?aname) (ModelID ?mid))
	=>
	(if (= ?num ?*count*) then
		(retract ?x ?y)
		(bind ?*count* 1)
	 else
	 		(retract ?y)
	 		(bind ?*count* (+ ?*count* 1))))	 		

(defrule MAIN::Remove_ConnectingOperator_3
	(declare (salience 1100))
	(OModel (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (FlowNum 1))
	?x <- (OConnectingOperator (ConnectingOperatorID ?cid))
	(EventFlow (ID ?eid) (ModelID ?mid) (From ?cid))
	(OEventFlow (EventFlowID ?eid))
	=>
	(retract ?x))

;***********************************************************
;*ConnectingOperator   EventFlow óϴ Rule
;***********************************************************	
(defrule MAIN::EventFlow_1
	(declare (salience 500))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(InitialPoint (ID ?iid) (ModelID ?id))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepID ?iid))
	(OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid) (ArtifactName ?alist1) (ArtifactOID $?aoid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist2) (From ?cid) (To ?tid))
	(test (= 0 (length$ $?aoid)))
	=>	
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?alist2) (Frequency 1)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::EventFlow_2
	(declare (salience 500))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepID ?iid))
	(OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid) (ArtifactName ?alist) (ArtifactOID $?aoid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist) (From ?cid) (To ?tid))
	(test (= 0 (length$ $?aoid)))
	=>	
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?alist) (Frequency 1)))
	(bind ?*id* (+ ?*id* 1)))
	
(defrule MAIN::EventFlow_3
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepID ?iid))
	(OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid) (ArtifactName ?alist) (ArtifactOID $?aoid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist) (From ?cid) (To ?tid))
  (test (<> 0 (length$ $?aoid)))
	=>
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?alist) (ArtifactOID ?aoid) (Frequency 1)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::EventFlow_4
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-OR) (StepID ?iid))
	?x <- (OConnectingOperator (OID ?coid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid) (ArtifactName ?artifact))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?artifact) (From ?cid) (To ?tid))
	=>
	(retract ?x)
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?artifact) (Frequency 1))))

(defrule MAIN::EventFlow_5
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	?x <- (RequestBranchMessage (ModelID ?mid) (RelativeConnectingOperatorID ?cid))
	?y <- (ResponseBranchMessage (ModelID ?mid) (RelativeConnectingOperatorID ?cid) (EventMessage ?msg))
	(EventFlow (ID ?eid) (ModelID ?mid) (Name ?msg) (ArtifactName ?artifact) (From ?cid) (To ?tid))
	=>
	(retract ?x ?y)
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?artifact) (Frequency 1))))

(defrule MAIN::EventFlow_6
	(declare (salience 600))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepID ?iid))
	(OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid))
	(EventFlow (ID ?eid) (ModelID ?mid) (From ?cid) (To ?tid))
  (ConnectingOperator (ID ?tid) (ModelID ?mid) (Type IN-OR) (StepState I) (StepID ?sid2))
  (Step (ID ?sid2) (ModelID ?mid) (Type Dummy))
  (ConnectingOperator (ID ?xid) (ModelID ?mid) (Type OUT-OR) (StepState E) (StepID ?sid2))
	=>	
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (Frequency 1)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::EventFlow_7
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(InitialPoint (ID ?iid) (ModelID ?mid))
	?x <- (OInitialPoint (ModelID ?mid) (InitialPointID ?iid))
	(EventFlow (ID ?eid) (ModelID ?mid) (From ?iid) (ArtifactName ?alist) (To ?tid))
	=>
	(retract ?x)
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ArtifactName ?alist) (ModelOID ?oid) (Frequency 1)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::EventFlow_8
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepID ?iid))
	(OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?iid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist) (From ?cid) (To ?tid))
	=>
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?alist) (Frequency 1)))
	(bind ?*id* (+ ?*id* 1)))

;***********************************************************
;*üȭ EventFlow ڿ οϴ Rule
;***********************************************************
(defrule MAIN::Modify_EventFlow_1
	(declare (salience 200))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?afname))
	?x <- (OEventFlow (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?afname) (ArtifactOID $?afoid) (Frequency ?fre))
	(ModelinputArtifact (ModelID ?mid) (ArtifactName ?afname) (ArtifactOID ?aoid))
	(test (= 0 (length$ $?afoid)))
	=>
	(modify ?x (ArtifactOID ?aoid) (Frequency (+ ?fre 1))))
	
;***********************************************************
;*ArtifactStore Artifact ûϴ Rule
;***********************************************************
(defrule MAIN::RequestArtifact_1
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ArtifactStore (ID ?asid) (ModelID ?mid) (Path ?p))
	(ArtifactFlow (ID ?afid) (ModelID ?mid) (From ?asid) (To ?cid) (ArtifactName ?aname))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type IN-AND))
	(EventFlow (ID ?eid) (ModelID ?mid) (To ?cid) (ArtifactName ?artifact))
	(OEventFlow (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?artifact))
	=>
	(assert (RequestArtifact (ModelID ?mid) (ArtifactStoreID ?asid) (ArtifactFlowID ?afid) (Path ?p) (ArtifactName ?aname))))

;***********************************************************
;*ArtifactStore   ArtifactFlow óϴ Rule 
;***********************************************************
(defrule MAIN::ArtifactFlow_1
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ArtifactStore (ID ?asid) (ModelID ?mid) (Path ?p))
	(ArtifactFlow (ID ?afid) (ModelID ?mid) (From ?asid) (To ?tid) (ArtifactName ?aname))
	?x <- (RequestArtifact (ModelID ?mid) (ArtifactStoreID ?asid) (ArtifactFlowID ?afid) (Path ?p) (ArtifactName ?aname))
	?y <- (ResponseArtifact (ModelID ?mid) (ArtifactStoreID ?asid) (ArtifactFlowID ?afid) (ArtifactName ?aname) (ArtifactOID ?aoid))
	=>
	(retract ?x ?y)
	(assert (OArtifactFlow (OID ?*id*) (ModelOID ?oid) (ArtifactFlowID ?afid) (ArtifactName ?aname) (ArtifactOID ?aoid)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::ArtifactFlow_2
	(declare (salience 700))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ArtifactStore (ID ?asid) (ModelID ?mid) (Path ?p))
	(ArtifactFlow (ID ?afid) (ModelID ?mid) (From ?cid) (To ?asid) (ArtifactName ?aname))
	(OConnectingOperator (ConnectingOperatorID ?cid) (ModelID ?mid))
	=>
	(assert (PutArtifact (ArtifactName ?aname) (ArtifactFlowID ?afid) (Path ?p) (ModelID ?mid)))
	(bind ?*id* (+ ?*id* 1)))

;*********************************************************
;*Step  ConnectingOperator óϴ Rule
;*********************************************************
(defrule MAIN::ConnectingOperator_2
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type IN-AND) (StepID ?sid) (FlowNum ?num))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?afname) (From ?fromid) (To ?cid))
	?x <- (OEventFlow (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?afname) (ArtifactOID $?afoid))
	(ArtifactFlow (ID ?aid) (ModelID ?mid) (From ?afid) (To ?cid) (ArtifactName ?aname))
	?y <- (OArtifactFlow (ModelOID ?oid) (ArtifactFlowID ?aid) (ArtifactName ?aname) (ArtifactOID ?aoid))
	(test (and (<> 0 (length$ $?afoid))
						 (<> 0 ?aoid)))
	=>
	(if (= (- ?num 1) ?*count*) then
		(retract ?x ?y)
		(if (= 0 (str-length ?*temp*)) then
			(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName (str-cat ?afname"+"?aname)) (ArtifactOID (create$ ?afoid ?aoid))))
		 else 
		  (assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName (str-cat ?afname"+"?aname ?*temp*)) (ArtifactOID (create$ ?afoid ?aoid)))))	
		(bind ?*id* (+ ?*id* 1))
		(bind ?*count* 1)
		(bind ?*temp* "")
	 else
	 	(retract ?y)
	 	(bind ?*temp* (str-cat ?*temp*"+"?aname))
	  (bind ?*count* (+ ?*count* 1))))

(defrule MAIN::ConnectingOperator_3
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type IN-AND) (StepID ?sid) (FlowNum ?num))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?afname) (From ?fromid) (To ?cid))
	?x <- (OEventFlow (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?afname) (ArtifactOID $?afoid))
	(ArtifactFlow (ID ?aid) (ModelID ?mid) (From ?afid) (To ?cid) (ArtifactName ?aname))
	?y <- (OArtifactFlow (ModelOID ?oid) (ArtifactFlowID ?aid) (ArtifactName ?aname) (ArtifactOID ?aoid))
	(test (<> 0 ?aoid))
	=>
	(if (= (- ?num 1) ?*count*) then
		(retract ?x ?y)
		(if (= 0 (str-length ?*temp*)) then
			(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName (str-cat ?afname"+"?aname)) (ArtifactOID (create$ ?afoid ?aoid))))
		 else 
		  (assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName (str-cat ?afname"+"?aname ?*temp*)) (ArtifactOID (create$ ?afoid ?aoid)))))	
		(bind ?*id* (+ ?*id* 1))
		(bind ?*count* 1)
		(bind ?*temp* "")
	 else
	 	(retract ?y)
	 	(bind ?*temp* (str-cat ?*temp*"+"?aname))
	  (bind ?*count* (+ ?*count* 1))))

(defrule MAIN::ConnectingOperator_4
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type IN-OR) (StepID ?sid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?afname) (From ?efid) (To ?cid))
  ?x <- (OEventFlow (OID ?eoid) (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?afname) (ArtifactOID $?roid))
	=>
	(retract ?x)
	(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName ?afname) (ArtifactOID ?roid)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::ConnectingOperator_5
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Step (ID ?sid) (Name ?sname) (ModelID ?mid)) ;(Type Primitive))
  ?w <- (OStep (OID ?soid) (ModelOID ?oid) (State E) (StepID ?sid))
  ?x <- (EndStep (StepID ?sid) (ModelID ?mid))
  ?y <- (InputArtifactInfo (Name ?iartifact) (StepID ?sid) (ModelID ?mid))
	?z <- (OutputArtifactInfo (Name ?oartifact) (StepID ?sid) (ModelID ?mid))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepState E) (StepID ?sid))		
	=>
	(retract ?w ?x ?y ?z)
	(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName ?oartifact)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::ConnectingOperator_6
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  ?w <- (OStep (OID ?soid) (ModelOID ?oid) (State E) (StepID ?sid))
  ?x <- (EndStep (StepID ?sid) (ModelID ?mid))
  ?y <- (InputArtifactInfo (Name ?iartifact) (StepID ?sid) (ModelID ?mid))
	?z <- (OutputArtifactInfo (Name ?oartifact) (StepID ?sid) (ModelID ?mid))
	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-OR) (StepState E) (StepID ?sid))		
	=>
	(retract ?w ?x ?y ?z)
	(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName ?oartifact)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::ConnectingOperator_7
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid1) (Name ?sname) (ModelID ?mid) (Type Primitive))
  ?x <- (OStep (OID ?soid) (ModelOID ?oid) (State E) (StepID ?sid))
  ?y <- (EndStep (StepID ?sid) (ModelID ?mid))
  (ConnectingOperator (ID ?fid) (ModelID ?mid) (Type OUT-AND) (StepState E) (StepID ?sid1))		
  (EventFlow (ModelID ?mid) (From ?fid) (To ?tid))
  (ConnectingOperator (ID ?tid) (ModelID ?mid) (Type IN-OR) (StepState I) (StepID ?sid2))
  (Step (ID ?sid2) (ModelID ?mid) (Type Dummy))
  (ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-OR) (StepState E) (StepID ?sid2))
  =>
  (retract ?x ?y)
  (assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?fid) (StepID ?sid1)))
  (bind ?*id* (+ ?*id* 1)))

;***********************************************************
;*dummy Step óϴ Rule 
;***********************************************************	
(defrule MAIN::dummy_1
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(ConnectingOperator (ID ?cid1) (ModelID ?mid) (StepState I) (StepID ?sid))
	(Step (ID ?sid) (ModelID ?mid) (Type Dummy))
	?x <- (OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid1) (StepID ?sid) (ArtifactName ?alist) (ArtifactOID $?aoid))
	(ConnectingOperator (ID ?cid2) (ModelID ?mid) (StepState E) (StepID ?sid))
	=>
	(retract ?x)
	(assert (OConnectingOperator (OID ?*id*) (ModelID ?mid) (ModelOID ?oid) (ConnectingOperatorID ?cid2) (StepID ?sid) (ArtifactName ?alist) (ArtifactOID ?aoid)))
	(bind ?*id* (+ ?*id* 1)))	


;***********************************************************
;*Step  غϴ Rule 
;***********************************************************	
(defrule MAIN::Step_Initiating_1
  (OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (StepState I) (StepID ?sid))
  (OConnectingOperator (OID ?coid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid))
  =>
  (assert (OStep (OID ?*id*) (ModelID ?mid) (State Initiating) (StepID ?sid) (ModelOID ?oid)))
  (bind ?*id* (+ ?*id* 1)))

(defrule MAIN::Step_Initiating_2
  (OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Compound) (CorrespondingModelID ?cmid))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (StepState I) (StepID ?sid))
  (OConnectingOperator (OID ?coid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName ?aname))
;  (test (<> ?cmid 0))
  =>
  (assert (LoadModel (ModelID ?cmid)))
  (assert (OStep (OID ?*id*) (ModelID ?mid) (State Initiating) (StepID ?sid) (ModelOID ?oid)))
  (bind ?*id* (+ ?*id* 1)))

;***********************************************************
;*Step ϴ  ʿ Է ڿ  ߰ϴ Rule 
;***********************************************************	
(defrule MAIN::Input_Artifact_Info_1
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid)) ;(Type Primitive))
  (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (StepState I) (StepID ?sid))
 	?x <- (OConnectingOperator (OID ?coid) (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid) (ArtifactName ?alist) (ArtifactOID $?aoid))
	=>
	(retract ?x)
  (assert (InputArtifactInfo (Name ?alist) (ArtifactOID ?aoid) (StepID ?sid) (ModelID ?mid))))
  
;*****************************************************************
;*Step  Ϸ  ؾ ϴ  ڿ  ߰ϴ Rule 
;*****************************************************************
(defrule MAIN::Output_Artifact_Info_1
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid)) ;(Type Primitive))
  (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepState E) (StepID ?sid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist) (From ?cid) (To ?etid))
	(ArtifactFlow (ID ?aid) (ModelID ?mid) (From ?cid) (To ?atid) (ArtifactName ?aname))
	=>
	(if (and (neq "" ?alist) (neq "" ?aname)) then
		(assert (OutputArtifactInfo (Name (str-cat ?alist"+"?aname)) (StepID ?sid) (ModelID ?mid) (Output Determined))))
	(if (and (neq "" ?alist) (eq "" ?aname)) then
		(assert (OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid) (Output Determined))))
	(if (and (eq "" ?alist) (neq "" ?aname)) then
		(assert (OutputArtifactInfo (Name ?aname) (StepID ?sid) (ModelID ?mid) (Output Determined)))))

(defrule MAIN::Output_Artifact_Info_2
  (OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-AND) (StepState E) (StepID ?sid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist) (From ?cid) (To ?etid))
	=>
  (assert (OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid) (Output Determined))))

(defrule MAIN::Output_Artifact_Info_3
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-OR) (StepState E) (StepID ?sid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?alist) (From ?cid) (To ?etid))
	=>
  (assert (Candidate_OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid))))  

(defrule MAIN::Output_Artifact_Info_4
	(declare (salience 100))
	?x <- (Candidate_OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid))
	=>
	(retract ?x)
	(assert (OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid) (Output NonDetermined))))
	
(defrule MAIN::Output_Artifact_Info_5
		(declare (salience 100))
		?x <- (Candidate_OutputArtifactInfo (Name ?aname) (StepID ?sid) (ModelID ?mid))
		?y <- (OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid) (Output NonDetermined))
		=>
		(retract ?x ?y)
		(assert (OutputArtifactInfo (Name (str-cat ?alist"+"?aname)) (StepID ?sid) (ModelID ?mid) (Output NonDetermined))))

;*****************************************************************
;*Step Ű Rule 
;*****************************************************************
(defrule MAIN::Initiate_Step_1
  (declare (salience 50))
  (OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  ?x <- (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
  (InputArtifactInfo (Name ?iartifact) (ArtifactOID $?afoid) (StepID ?sid) (ModelID ?mid))
  (OutputArtifactInfo (Name ?oartifact) (StepID ?sid) (ModelID ?mid) (Output Determined))
  (Worker (Type ?wtype) (WorkerOID ?woid) (StepID ?sid) (ModelID ?mid))
  (NumberOfWorker (ModelID ?mid) (StepID ?sid) (WorkerNum ?wnum))
  =>
  (if (= ?wnum ?*count*) then
    (assert (InitiateStep (WorkerOID ?woid) (StepName ?sname) (StepID ?sid) (ModelID ?mid)))
    (retract ?x)
    (assert (OStep (OID ?soid) (ModelID ?mid) (State I) (StepID ?sid) (ModelOID ?oid)))
    (assert (EndStep (StepID ?sid) (ModelID ?mid)))
 		(bind ?*count* 1)
   else
    (assert (InitiateStep (WorkerOID ?woid) (StepName ?sname) (StepID ?sid) (ModelID ?mid)))
    (bind ?*count* (+ ?*count* 1))))

(defrule MAIN::Initiate_Step_2
  (declare (salience 50))
  (OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  ?x <- (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
 	(ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-OR) (StepState E) (StepID ?sid))
  (InputArtifactInfo (Name ?iartifact) (ArtifactOID $?afoid) (StepID ?sid) (ModelID ?mid))
  (OutputArtifactInfo (Name ?oartifact) (StepID ?sid) (ModelID ?mid) (Output NonDetermined))
  (Worker (Type ?wtype) (WorkerOID ?woid) (StepID ?sid) (ModelID ?mid))
  (NumberOfWorker (ModelID ?mid) (StepID ?sid) (WorkerNum ?wnum))
  =>
  (if (= ?wnum ?*count*) then
	  (assert (InitiateStep (WorkerOID ?woid) (StepName ?sname) (StepID ?sid) (ModelID ?mid)))
    (retract ?x)
    (assert (OStep (OID ?soid) (ModelID ?mid) (State I) (StepID ?sid) (ModelOID ?oid)))
    (assert (EndStep (StepID ?sid) (ModelID ?mid)))
    (bind ?*count* 1)
   else
   	(assert (InitiateStep (WorkerOID ?woid) (StepName ?sname) (StepID ?sid) (ModelID ?mid)))
   	(bind ?*count* (+ ?*count* 1)))) 

(defrule MAIN::Initiate_Step_3
  (declare (salience 50))
  (OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Compound))
  ?x <- (OStep (OID ?soid) (State Initiating) (StepID ?sid) (ModelOID ?oid))
  (InputArtifactInfo (Name ?iartifact) (ArtifactOID $?afoid) (StepID ?sid) (ModelID ?mid))
  (OutputArtifactInfo (Name ?oartifact) (StepID ?sid) (ModelID ?mid) (Output Determined))
  =>
  (assert (InitiateStep (StepName ?sname) (StepID ?sid) (ModelID ?mid)))
  (retract ?x)
  (assert (OStep (OID ?soid) (ModelID ?mid) (State I) (StepID ?sid) (ModelOID ?oid))))

   	
;*****************************************************************
;*Step   ϴ Rule
;*****************************************************************
(defrule MAIN::Initiate_Step_Info_1
	(declare (salience 1000))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid)) ;(Type Primitive))
  (InputArtifactInfo (Name ?iartifact) (ArtifactOID $?afoid) (StepID ?sid) (ModelID ?mid))
  (OutputArtifactInfo (Name ?oartifact) (StepID ?sid) (ModelID ?mid))
  (Worker (Type ?wtype) (WorkerOID ?woid) (StepID ?sid) (ModelID ?mid))
  (InitiateStep (WorkerOID ?woid) (StepID ?sid) (ModelID ?mid))
  =>
  (assert (InitiateStepInfo (ModelID ?mid) (StepID ?sid) (Step ?sname) (Input ?iartifact) (Output ?oartifact) (WorkerType ?wtype) (Worker ?woid))))

;*****************************************************************
;* Ű Rule
;*****************************************************************
(defrule MAIN::Initiate_Corressponding_Model_1
	(declare (salience 2000))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(LoadModel (ModelID ?cmid))
	(Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Compound) (CorrespondingModelID ?cmid))
	(InitiateStep (StepID ?sid) (ModelID ?mid))
	(InputArtifactInfo (Name ?ialist) (StepID ?sid) (ModelID ?mid) (ArtifactOID $?aoid))
	=>
	(assert (InitiateCorrespondingModel (PreviousModelID ?mid) (CompoundStepID ?sid) (ModelName ?sname) (ModelID ?cmid) (InputArtifact ?ialist) (InputArtifactOID ?aoid))))
  
;*****************************************************************
;*Step    Step ¸ Ű Rule 
;*****************************************************************
(defrule MAIN::End_Step_1
	(declare (salience 50))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  ?x <- (InitiateStep (StepName ?sname) (StepID ?sid) (ModelID ?mid))
  ?y <- (InitiateStepInfo (ModelID ?mid) (StepID ?sid)) 
  (OStep (OID ?soid) (State I) (StepID ?sid) (ModelOID ?oid))
  (EndStep (StepID ?sid) (ModelID ?mid))
  =>
  (retract ?x ?y))  

(defrule MAIN::End_Step_2
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  ?x <- (OStep (OID ?soid) (State I) (StepID ?sid) (ModelOID ?oid))
  (EndStep (StepID ?sid) (ModelID ?mid))
  =>
  (retract ?x)
  (assert (OStep (OID ?soid) (ModelID ?mid) (State E) (StepID ?sid) (ModelOID ?oid))))
  
(defrule MAIN::End_Step_3
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Primitive))
  (OStep (State E) (StepID ?sid) (ModelOID ?oid))
	?x <- (Worker (StepID ?sid) (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::End_Step_4
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Step (ID ?sid) (Name ?sname) (ModelID ?mid) (Type Compound))
	?x <- (InitiateStep (StepName ?sname) (StepID ?sid) (ModelID ?mid))
	?y <- (OStep (OID ?soid) (State I) (StepID ?sid) (ModelOID ?oid))
	(LoadModel (ModelID ?exmid))
	(TerminateModel (ModelID ?exmid))
	=>
	(retract ?x ?y)
	(assert (EndStep (StepID ?sid) (ModelID ?mid)))
	(assert (OStep (OID ?soid) (ModelID ?mid) (State E) (StepID ?sid) (ModelOID ?oid))))

;*****************************************************************
;*Step    Step Output Artifact  ϴ Rule 
;*****************************************************************  
(defrule MAIN::Modify_OutputArtifact_Info_1
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(EndStep (StepID ?sid) (ModelID ?mid))
	(OStep (State E) (StepID ?sid))
  (OutputArtifactInfo (Name ?oartifact) (EventFlowName "nothing") (StepID ?sid) (ModelID ?mid) (Output NonDetermined))
  =>
  (assert (EnterBranchMessage (ModelID ?mid))))
  
(defrule MAIN::Modify_OutputArtifact_Info_2
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	?x <- (EnterBranchMessage (ModelID ?mid))
	?y <- (EnteredBranchMessage (Message ?msg))
	(EndStep (StepID ?sid) (ModelID ?mid))
	(OStep (State E) (StepID ?sid))
  ?z <- (OutputArtifactInfo (Name ?oartifact) (EventFlowName "nothing") (StepID ?sid) (ModelID ?mid) (Output NonDetermined))
   =>
	(retract ?x ?y ?z)
	(assert (OutputArtifactInfo (Name ?oartifact) (EventFlowName ?msg) (StepID ?sid) (ModelID ?mid) (Output NonDetermined))))
	
(defrule MAIN::Modify_OutputArtifact_Info_3
	(declare (salience 100))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(EndStep (StepID ?sid) (ModelID ?mid))
	(OStep (State E) (StepID ?sid))
	?x <- (OutputArtifactInfo (Name ?oartifact) (EventFlowName ?event) (StepID ?sid) (ModelID ?mid) (Output NonDetermined))
	(EventFlow (Name ?event) (ArtifactName ?alist))
	=>
	(retract ?x)
	(assert (OutputArtifactInfo (Name ?alist) (StepID ?sid) (ModelID ?mid) (Output Determined))))

;*****************************************************************
;*޽  б⸦ ϴ Rule 
;***************************************************************** 
(defrule MAIN::Request_Branch_Message
	(declare (salience 600))
	(OModel (OID ?oid) (ModelID ?mid) (State I))
  (Step (ID ?sid1) (Name ?sname) (ModelID ?mid) (Type Primitive))
  (ConnectingOperator (ID ?fid) (ModelID ?mid) (Type OUT-AND) (StepState E) (StepID ?sid1))		
  (EventFlow (ModelID ?mid) (From ?fid) (To ?tid))
	(ConnectingOperator (ID ?tid) (ModelID ?mid) (Type IN-OR) (StepState I) (StepID ?sid2))
  (Step (ID ?sid2) (ModelID ?mid) (Type Dummy))
  (ConnectingOperator (ID ?cid) (ModelID ?mid) (Type OUT-OR) (StepState E) (StepID ?sid2))
  ?x <- (OConnectingOperator (ModelOID ?oid) (ConnectingOperatorID ?cid) (StepID ?sid2))
	=>
	(retract ?x)
	(assert (RequestBranchMessage (ModelID ?mid) (RelativeConnectingOperatorID ?cid))))

;*****************************************************************
;*б  ȣ ãư Rule 
;***************************************************************** 
(defrule MAIN::Numbers_1
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(EventFlow (ID ?eid) (ModelID ?mid) (Name ?ename) (ArtifactName ?artifact))
	?x <- (OEventFlow (EventFlowID ?eid) (ModelOID ?oid) (ArtifactName ?artifact))
	(Numbers (ID ?inid) (ModelID ?mid) (Name ?num) (EventName ?ename) (InEvent ?eid) (Artifact ?artifact))
	=>	
	(retract ?x)
	(assert (ONumbers (ID ?*id*) (ModelID ?mid) (ModelOID ?oid) (NumberID ?inid) (Type IN)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::Numbers_2
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Numbers (ID ?inid) (ModelID ?mid) (Name ?num) (EventName ?ename) (InEvent ?eid) (Artifact ?artifact))
	(Numbers (ID ?outid) (ModelID ?mid) (Name ?num) (OutEvent ?out))
  ?x <-	(ONumbers (ModelOID ?oid) (NumberID ?inid) (Type IN))
  (test (<> ?inid ?outid))
  =>
  (retract ?x)
  (assert (ONumbers (ID ?*id*) (ModelID ?mid) (ModelOID ?oid) (NumberID ?outid) (Type OUT)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::Numbers_3
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(Numbers (ID ?inid) (ModelID ?mid) (Name ?num) (EventName ?ename) (InEvent ?eid) (Artifact ?artifact))
	(Numbers (ID ?outid) (ModelID ?mid) (Name ?num) (OutEvent ?out))
	?x <- (ONumbers (ModelOID ?oid) (NumberID ?outid) (Type OUT))
	?y <- (EventFlow (ID ?out) (ModelID ?mid) (From ?fid) (To ?tid))
  (test (<> ?inid ?outid))
	=>
	(retract ?x ?y)
	(assert (EventFlow (ID ?out) (ModelID ?mid) (Name ?ename) (ArtifactName ?artifact) (From ?fid) (To ?tid)))
	(assert (OEventFlow (OID ?*id*) (EventFlowID ?out) (ArtifactName ?artifact) (ModelOID ?oid)))
	(bind ?*id* (+ ?*id* 1)))

;*****************************************************************
;* Ű Rule
;***************************************************************** 
(defrule MAIN::End_Model_1
	(OModel (OID ?oid) (ModelID ?mid) (State I))
	(FinalPoint (ID ?fid) (ModelID ?mid))
	(EventFlow (ID ?eid) (ModelID ?mid) (ArtifactName ?aname) (To ?fid))
	?x <- (OEventFlow (EventFlowID ?eid) (ModelOID ?oid))
	=>
	(retract ?x)
  (assert (OFinalPoint (OID ?*id*) (ModelID ?mid) (FinalPointID ?fid)))
	(bind ?*id* (+ ?*id* 1)))

(defrule MAIN::Terminate_Model_1
	(Model (ID ?mid) (Name ?name))
	?x <- (OModel (OID ?oid) (ModelID ?mid) (State I))
	(FinalPoint (ID ?fid) (ModelID ?mid))
	?y <- (OFinalPoint (ModelID ?id) (FinalPointID ?fid))	
	=>
	(retract ?x ?y)
	(assert (TerminateModel (ModelID ?mid))))

(defrule MAIN::RetModel
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Model (ID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetStep
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Step (ModelID ?mid))
	=>
	(retract ?x))
	
(defrule MAIN::RetInitialPoint
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (InitialPoint (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetMetaPoint
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (MetaPoint (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetFinalPoint
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (FinalPoint (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetResource
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Resource (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetArtifactStore
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (ArtifactStore (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetOrganization
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Organization (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetEventBinder
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (EventBinder (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetPrecondition
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Precondition (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetPostcondition
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Postcondition (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetLink
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (Link (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetNumberOfWorker
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (NumberOfWorker (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetArtifactFlow
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (ArtifactFlow (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetEventFlow
	(declare (salience 10000))
  (TerminateModel (ModelID ?mid))
	?x <- (EventFlow (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetConnectingOperator
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (ConnectingOperator (ModelID ?mid))
	=>
	(retract ?x))

(defrule MAIN::RetModelinputArtifact
	(declare (salience 10000))
	(TerminateModel (ModelID ?mid))
	?x <- (ModelinputArtifact (ModelID ?mid))
	=>
	(retract ?x))
